package com.xeround.bankmark;
import java.io.Serializable;

//abstract class account
public abstract class Account implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 3795554476411848962L;
	private int accountNumber;
	private double balance;
	private Customer customer;


	protected Account(Customer customer, double openingBalance, int accountNumber) {
		this.customer = customer;
		setBalance(openingBalance);
		this.accountNumber = accountNumber;
	}// end constructor

	public void setAccountNumber() {
		this.accountNumber++;
	}

	protected int getAccountNumber() {
		return accountNumber;
	}// end getAccountNumber

	// method returns balance, use to add balances in all accounts
	public double getBalance() {
		return balance;
	}// end getBalance

	//start setBalance
	protected void setBalance(double balance) {
		this.balance = balance;
	}// end setBalance

	// Not all accounts withdraw the same way, so method not implemented
	// here
	abstract void withdraw(double amount);// end withdraw

	// all accounts deposit the same way
	public void deposit(double depositAmount) {
		this.balance = getBalance() + depositAmount;
	}// end deposit

	abstract void monthlyUpdate();// end update


	public Customer getCustomer() {
		return customer;
	}

	public void setCustomer(Customer customer) {
		this.customer = customer;
	}
	//////#########All toStrings....Why parse numbers to strings for textfields or rewrite this for 
	//each GUI every time?
	public String accountAllInfotoString() {
		String accountInfo = "Customer: \n _______\n" + getCustomer() + "\n" +
				"Acct #: " + getAccountNumber() + "\n" +
						"Balance: "	 + getBalance() + "\n";
		return String.format("%s", accountInfo);
	}
	public String accountNumberToString() {
		int accountInfo = getAccountNumber();
		return String.format("%s", accountInfo);
	}

	public String accountBalanceToString() {
		double customerInfo = getBalance();
		return String.format("%s", customerInfo);
	}

	public String accountCustomerToString() {
		String customerInfo = getCustomer().toString();
		return String.format("%s", customerInfo);
	}
	//wen the account object is called in jlist toString is used
	//so i end up having two methods here for account number
	public String toString() {
		int accountInfo = getAccountNumber();
		return String.format("%d", accountInfo);
	}// end toString
	public String getAccountNumberToString(){
		int temp = getAccountNumber();
		return String.format("%d", temp);
	}

	public String getBalanceToString(){
		double temp = getBalance();
		return String.format("%d.2", temp);
	}
}// end Account class
