package com.xeround.bankmark;
import javax.swing.JOptionPane;

//Class CheckingAccount
public class CheckingAccount extends Account {
	/**
	 * 
	 */
	private static final long serialVersionUID = -1548051623050986412L;
	private final double defaultTransactionFee = 3.00;
	private double transactionFee;
	private int defaultFreeTransactions = 2;
	private int freeTransactions;
	private int accountNumber;

	public CheckingAccount(Customer customer, double openingBalance, int accountNumber) {
		super(customer, openingBalance, accountNumber);	
		useDefaultTransactionFee();
		useDefaultFreeTransactions();	
	}// end constructor for CheckingAccount


	public void setTransactionFee(double transactionFee) {
		this.transactionFee = transactionFee;
	}


	public int getFreeTransactions() {
		return freeTransactions;
	}
	
	public void setFreeTransactions(int freeTransactions) {
		this.freeTransactions = freeTransactions;
	}


	private void useDefaultFreeTransactions(){
		freeTransactions = defaultFreeTransactions;
	}

	public double getTransactionFee() {
		return transactionFee;
	}// end TransactionFee
	
	public String getTransactionFeeToString(){
		double temp = getTransactionFee();
		return String.format("%d.2", temp);
	}
	public String getFreeTransactionsToString(){
		double temp = getFreeTransactions();
		return String.format("%d.2", temp);
	}
	
	
	public double getDefaultTransactionFee() {
		return defaultTransactionFee;
	}
	public void useDefaultTransactionFee(){
		transactionFee = defaultTransactionFee;
	}
	//
	// will reset the transactionMade field so client is not charged
	// $3.00 transaction fee for first two withdraws
	// method final because this is concrete class
	@Override
	void monthlyUpdate() {	
		freeTransactions = 2;	
	}
	
	// deposit is same for all accounts // call Account's method// Not necessary
	// to add this method as it is inherited anyway.
	public void deposit(double deposit) {
		super.deposit(deposit);
	}// end deposit

	@Override
	// // Polymorphism here, overriding Account's withdraw
	// method final because this is concrete class
	final void withdraw(double amount) {
				if (amount <= super.getBalance()) {
					if (getFreeTransactions() >= 0 ) {
						double tempBalance = super.getBalance()
								- amount;
						super.setBalance(tempBalance);
						freeTransactions--;
					} else {
						double tempBal = (super.getBalance() - amount)
								- transactionFee;
						super.setBalance(tempBal);
						freeTransactions--;
					}
				} else {
					JOptionPane.showMessageDialog(null, "Insufficient Funds");
				}
	}// end withdraw

	// start toString
	public String toString() {
		String checkAccInfo = super.toString();
		return String.format("%s", checkAccInfo);
	}// end toString()


	public int getAccountNumber() {
		return accountNumber;
	}


	public void setAccountNumber(int accountNumber) {
		this.accountNumber = accountNumber;
	}



	
}// end CheckingAccount Class
