package com.xeround.bankmark;
import java.awt.Window;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.ImageIcon;
import javax.swing.JList;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

import java.awt.Font;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.LayoutStyle.ComponentPlacement;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Color;
import javax.swing.JTextArea;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;

public class EditCustomerGUI extends JFrame {
	/**
	 * 
	 */
	private static final long serialVersionUID = -4242668213630026002L;
	private static EditCustomerGUI instance = null;
	private JPanel contentPane;
	final Window container = this;
	private JTextField custName;
	private JTextField custAddress;
	private JTextField custPhone;
	private JTextField custID;
	private JButton btnModify;
	private JLabel lblSelectCustomer;
	private JLabel lblcustNameError;
	private JLabel lblcustAddressError;
	private JLabel lblcustPhoneError;
	private JLabel lblcustIDError;
	private JButton btnClose;
	private String customerName;
	private int customerID;
	private String customerAddress;
	private String customerPhone;
	MyListIterator cursor;
	private ImageIcon successIcon = new ImageIcon("images/success.png");
	private ImageIcon failIcon = new ImageIcon("images/fail.png");
	private int selectedIndex = 0;
	private Customer selectedCustomer;
	private JTextArea custInfoDisplay;
	private JLabel lblCustomerInformation;
	private MyListModel temp = new MyListModel();
	private JList<Customer> custList = new JList<Customer>();

	/**
	 * Create the frame.
	 */
	public EditCustomerGUI() {
		cursor = CustomerList.getInstance().getCursor();//added
		setTitle("Edit Customer Information");
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(100, 100, 550, 325); //frame size
		contentPane = new JPanel();
		container.add(contentPane);
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		
	
		
		custList.setBackground(new Color(255, 255, 255));
		custList.setSelectedIndex(selectedIndex);
		
		JLabel lblName = new JLabel("Name:");
		lblName.setFont(new Font("Tahoma", Font.PLAIN, 12));
		
		custName = new JTextField();
		custName.addFocusListener(new FocusAdapter() {
			@Override
			public void focusLost(FocusEvent e) {
				String pattern = "\\w.*?";
				if (custName.getText().matches(pattern)) {
					
					lblcustNameError.setText("");
					lblcustNameError
							.setIcon(successIcon);
				} else {
					lblcustNameError.setText("Invalid, Name Required");
					lblcustNameError.setIcon(failIcon);
					lblcustNameError.setEnabled(false);
				}
			}
		});
		custName.setColumns(10);
		
		JLabel lblAddress = new JLabel("Address:");
		lblAddress.setFont(new Font("Tahoma", Font.PLAIN, 12));
		
		custAddress = new JTextField();
		custAddress.addFocusListener(new FocusAdapter() {
			@Override
			public void focusLost(FocusEvent e) {
				String pattern = "\\w.*?";
				if (custAddress.getText().matches(pattern)) {
					lblcustAddressError.setText("");
					lblcustAddressError.setIcon(successIcon);
				} else {
					lblcustAddressError.setText("Invalid, Include Address");
					lblcustAddressError
							.setIcon(failIcon);
					lblcustAddressError.setEnabled(false);
				}
			}
		});
		custAddress.setColumns(10);
		
		JLabel lblPhone = new JLabel("Phone:");
		lblPhone.setFont(new Font("Tahoma", Font.PLAIN, 12));
		
		custPhone = new JTextField();
		custPhone.addFocusListener(new FocusAdapter() {
			@Override
			public void focusLost(FocusEvent e) {
				String pattern = "\\(*?\\d{3}[\\w'-]*?\\d{3}[\\w'-]*?\\d{4}";
				if (custPhone.getText().matches(pattern)) {
					lblcustPhoneError.setText("");
					lblcustPhoneError.setIcon(successIcon);
				} else {
					lblcustPhoneError.setText("Format 555-123-1234");
					lblcustPhoneError.setIcon(failIcon);
					lblcustPhoneError.setEnabled(false);
				}
			}
		});
		custPhone.setColumns(10);
		
		JLabel lblCustomerId = new JLabel("Customer ID:");
		lblCustomerId.setFont(new Font("Tahoma", Font.PLAIN, 12));
		
		custID = new JTextField();
		custID.addFocusListener(new FocusAdapter() {
			@Override
			public void focusLost(FocusEvent e) {
				String pattern = "\\d.*?";
				if (custID.getText().matches(pattern)) {
					lblcustIDError.setText("");
					lblcustIDError.setIcon(successIcon);
					lblcustIDError.setEnabled(true);
				} else {
					lblcustIDError.setText("Must be an Number");
					lblcustIDError.setIcon(failIcon);
					lblcustIDError.setEnabled(false);
				}
			}
		});
		custID.setColumns(10);
		
		btnModify = new JButton("Modify");
		btnModify.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String pattern = "\\w.*?";
				String pattern2 = "\\(*?\\d{3}[\\w'-]*?\\d{3}[\\w'-]*?\\d{4}";
				String pattern3 = "\\d.*?";
				if (!(custList.isSelectionEmpty())){
				if (custName.getText().matches(pattern)) {
					if (custAddress.getText().matches(pattern)) {
						if (custPhone.getText().matches(pattern2)) {
							if (custID.getText().matches(pattern3)) {							
								setCustomerName(custName.getText());
								setCustomerAddress(custAddress.getText());
								setCustomerPhone(custPhone.getText());
								setCustomerID(Integer.parseInt(custID.getText()));
								custList.getSelectedValue().setCustomerName(custName.getText());
								custList.getSelectedValue().setCustomerAddress(custAddress.getText());
								custList.getSelectedValue().setCustomerPhone(custPhone.getText());
								custList.getSelectedValue().setCustomerID(Integer.parseInt(custID.getText()));
								custInfoDisplay.setText(custList.getSelectedValue()
										.custAllInfotoString());
								temp.customerPopulateJList(custList);
							}
						}
					}
				}
				}else {
					JOptionPane.showMessageDialog(null, "You have to select a customer");
				}
				}
		});
		
		lblSelectCustomer = new JLabel("Select Customer");
		lblSelectCustomer.setForeground(new Color(0, 51, 255));
		lblSelectCustomer.setFont(new Font("Tahoma", Font.PLAIN, 14));
		
		lblcustNameError = new JLabel("");
		lblcustNameError.setForeground(new Color(255, 0, 0));
		
		lblcustAddressError = new JLabel("");
		lblcustAddressError.setForeground(new Color(255, 0, 0));
		
		lblcustPhoneError = new JLabel("");
		lblcustPhoneError.setForeground(new Color(255, 0, 0));
		
		lblcustIDError = new JLabel("");
		lblcustIDError.setForeground(new Color(255, 0, 0));
		
		btnClose = new JButton("Close");
		btnClose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				container.dispose();
			}
		});
		
		custInfoDisplay = new JTextArea();
		custInfoDisplay.setEditable(false);
		custInfoDisplay.setBackground(new Color(204, 204, 204));
		temp.customerPopulateJList(custList);
		custList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				if (evt.getValueIsAdjusting()) {
					custInfoDisplay.setText(custList.getSelectedValue()
							.custAllInfotoString());
					setSelectedCustomer(custList.getSelectedValue());
					custName.setText(getSelectedCustomer().custNameToString());
					custAddress.setText(getSelectedCustomer().custAddressToString());
					custPhone.setText(getSelectedCustomer().custPhoneToString());
					custID.setText(getSelectedCustomer().custIDToString());
					/*
					 * add setText to textfields for selected customer from jlist
					 */
				}
			}
		});
		
		lblCustomerInformation = new JLabel("Customer Information");
		GroupLayout gl_contentPane = new GroupLayout(contentPane);
		gl_contentPane.setHorizontalGroup(
			gl_contentPane.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addContainerGap()
					.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addGap(4)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
								.addGroup(gl_contentPane.createSequentialGroup()
									.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
										.addComponent(custList, GroupLayout.PREFERRED_SIZE, 156, GroupLayout.PREFERRED_SIZE)
										.addComponent(lblCustomerInformation))
									.addPreferredGap(ComponentPlacement.RELATED)
									.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
										.addComponent(lblAddress, Alignment.TRAILING)
										.addComponent(lblName, Alignment.TRAILING)
										.addComponent(lblPhone, Alignment.TRAILING)
										.addComponent(lblCustomerId, Alignment.TRAILING)))
								.addComponent(custInfoDisplay, GroupLayout.PREFERRED_SIZE, 152, GroupLayout.PREFERRED_SIZE))
							.addPreferredGap(ComponentPlacement.RELATED)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
								.addComponent(btnClose, GroupLayout.DEFAULT_SIZE, 139, Short.MAX_VALUE)
								.addComponent(btnModify, GroupLayout.DEFAULT_SIZE, 139, Short.MAX_VALUE)
								.addComponent(custID, GroupLayout.DEFAULT_SIZE, 139, Short.MAX_VALUE)
								.addComponent(custPhone, 139, 139, Short.MAX_VALUE)
								.addComponent(custAddress, 139, 139, Short.MAX_VALUE)
								.addComponent(custName, GroupLayout.DEFAULT_SIZE, 139, Short.MAX_VALUE))
							.addPreferredGap(ComponentPlacement.UNRELATED)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
								.addComponent(lblcustIDError, GroupLayout.DEFAULT_SIZE, 133, Short.MAX_VALUE)
								.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING, false)
									.addComponent(lblcustAddressError, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
									.addComponent(lblcustNameError, GroupLayout.DEFAULT_SIZE, 133, Short.MAX_VALUE)
									.addComponent(lblcustPhoneError, Alignment.TRAILING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
							.addGap(46))
						.addGroup(gl_contentPane.createSequentialGroup()
							.addComponent(lblSelectCustomer)
							.addContainerGap(464, Short.MAX_VALUE))))
		);
		gl_contentPane.setVerticalGroup(
			gl_contentPane.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING, false)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addGap(8)
							.addComponent(lblSelectCustomer)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(custList, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
						.addGroup(gl_contentPane.createSequentialGroup()
							.addGap(40)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING, false)
								.addComponent(lblcustNameError, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addComponent(custName, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
								.addComponent(lblName))
							.addPreferredGap(ComponentPlacement.RELATED)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING, false)
								.addComponent(lblcustAddressError, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addComponent(lblAddress)
								.addComponent(custAddress, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
							.addPreferredGap(ComponentPlacement.RELATED)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING, false)
								.addComponent(lblcustPhoneError, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addComponent(lblPhone)
								.addComponent(custPhone, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))))
					.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
						.addGroup(Alignment.LEADING, gl_contentPane.createSequentialGroup()
							.addPreferredGap(ComponentPlacement.RELATED)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING, false)
								.addComponent(custID, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
								.addComponent(lblcustIDError, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addComponent(lblCustomerId, Alignment.LEADING))
							.addGap(18)
							.addComponent(btnModify)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(btnClose)
							.addContainerGap())
						.addGroup(gl_contentPane.createSequentialGroup()
							.addGap(5)
							.addComponent(lblCustomerInformation)
							.addPreferredGap(ComponentPlacement.UNRELATED)
							.addComponent(custInfoDisplay, GroupLayout.PREFERRED_SIZE, 80, GroupLayout.PREFERRED_SIZE))))
		);
		contentPane.setLayout(gl_contentPane);
		setLocation(600, 200); // position frame
	}

	public Customer getSelectedCustomer() {
		return selectedCustomer;
	}

	public void setSelectedCustomer(Customer selectedCustomer) {
		this.selectedCustomer = selectedCustomer;
	}

	public String getCustomerName() {
		return customerName;
	}

	public void setCustomerName(String customerName) {
		this.customerName = customerName;
	}

	public int getCustomerID() {
		return customerID;
	}

	public void setCustomerID(int customerID) {
		this.customerID = customerID;
	}

	public String getCustomerAddress() {
		return customerAddress;
	}

	public void setCustomerAddress(String customerAddress) {
		this.customerAddress = customerAddress;
	}

	public String getCustomerPhone() {
		return customerPhone;
	}

	public void setCustomerPhone(String customerPhone) {
		this.customerPhone = customerPhone;
	}

	public int getSelectedIndex() {
		return selectedIndex;
	}

	public void setSelectedIndex(int selectedIndex) {
		this.selectedIndex = selectedIndex;
	}
	public static EditCustomerGUI getInstance() {
		if (instance == null) {
			instance = new EditCustomerGUI();
		}
		return instance;
	}

}
