package com.xeround.bankmark;

import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.JButton;
import java.awt.Color;
import javax.swing.ImageIcon;
import javax.swing.JSeparator;
import javax.swing.JTextPane;
import javax.swing.JMenuItem;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class GUIMain extends JFrame {
	/**
	 * 
	 */
	private static final long serialVersionUID = 6329651346305717555L;
	SaveOpenLists saveAction = new SaveOpenLists();

	/**
	 * Create the frame.
	 */
	public GUIMain() {
		getContentPane().setBackground(new Color(255, 255, 204));
		setForeground(new Color(255, 255, 204));
		setBackground(new Color(255, 255, 255));
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(200, 200, 600, 400);
		setLocation(300, 200);
		// setLocationRelativeTo(null); // for centered window
		// Toolkit.getDefaultToolkit().getScreenSize(); //gets screen size for
		// any monitor
		JLabel lblNewLabel = new JLabel("New label");
		lblNewLabel.setIcon(new ImageIcon("images\\bank.png"));

		JButton btnMonthlyProcessing = new JButton("Monthly Processing");

		JButton btnTransactions = new JButton("Transactions");
		btnTransactions.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				TransactionGUI trans = new TransactionGUI();
				trans.setVisible(true);
			}
		});

		JButton btnRefresh = new JButton("Refresh");

		JButton btnExit = new JButton("Exit");
		btnExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// write customer list to file
				System.exit(1);
			}
		});

		JTextPane textPane = new JTextPane();
		textPane.setEditable(false);
		GroupLayout groupLayout = new GroupLayout(getContentPane());
		groupLayout
				.setHorizontalGroup(groupLayout
						.createParallelGroup(Alignment.LEADING)
						.addGroup(
								groupLayout
										.createSequentialGroup()
										.addContainerGap()
										.addGroup(
												groupLayout
														.createParallelGroup(
																Alignment.LEADING)
														.addGroup(
																groupLayout
																		.createSequentialGroup()
																		.addComponent(
																				btnMonthlyProcessing,
																				GroupLayout.DEFAULT_SIZE,
																				143,
																				Short.MAX_VALUE)
																		.addPreferredGap(
																				ComponentPlacement.UNRELATED)
																		.addComponent(
																				btnTransactions)
																		.addPreferredGap(
																				ComponentPlacement.UNRELATED)
																		.addComponent(
																				btnRefresh,
																				GroupLayout.PREFERRED_SIZE,
																				91,
																				GroupLayout.PREFERRED_SIZE)
																		.addPreferredGap(
																				ComponentPlacement.RELATED)
																		.addComponent(
																				btnExit,
																				GroupLayout.PREFERRED_SIZE,
																				61,
																				GroupLayout.PREFERRED_SIZE))
														.addGroup(
																groupLayout
																		.createSequentialGroup()
																		.addComponent(
																				lblNewLabel,
																				GroupLayout.PREFERRED_SIZE,
																				202,
																				GroupLayout.PREFERRED_SIZE)
																		.addGap(18)
																		.addComponent(
																				textPane,
																				GroupLayout.DEFAULT_SIZE,
																				194,
																				Short.MAX_VALUE)))
										.addContainerGap()));
		groupLayout
				.setVerticalGroup(groupLayout
						.createParallelGroup(Alignment.LEADING)
						.addGroup(
								groupLayout
										.createSequentialGroup()
										.addContainerGap()
										.addGroup(
												groupLayout
														.createParallelGroup(
																Alignment.LEADING)
														.addComponent(
																lblNewLabel,
																GroupLayout.PREFERRED_SIZE,
																196,
																Short.MAX_VALUE)
														.addComponent(
																textPane,
																GroupLayout.DEFAULT_SIZE,
																201,
																Short.MAX_VALUE))
										.addPreferredGap(
												ComponentPlacement.RELATED)
										.addGroup(
												groupLayout
														.createParallelGroup(
																Alignment.BASELINE)
														.addComponent(
																btnMonthlyProcessing)
														.addGroup(
																groupLayout
																		.createParallelGroup(
																				Alignment.LEADING)
																		.addComponent(
																				btnExit)
																		.addComponent(
																				btnTransactions)
																		.addComponent(
																				btnRefresh)))));
		getContentPane().setLayout(groupLayout);

		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);

		JMenu mnFile = new JMenu("File");
		mnFile.setMnemonic('F');
		menuBar.add(mnFile);

		JMenuItem mntmExit = new JMenuItem("Exit");
		mntmExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				System.out.print("Working");
				if (saveAction == null) {// if it does not equal null then can't
											// exit
					String message = "Exit without Saving?";
					String title = "Exit";
					int reply = JOptionPane.showConfirmDialog(null, message,
							title, JOptionPane.YES_NO_OPTION);
					if (reply == JOptionPane.YES_OPTION) {
						System.exit(getDefaultCloseOperation());
					}// return needed???
				}
			}
		});

		JMenuItem mntmSaveAll = new JMenuItem("Save All");
		mntmSaveAll.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (SaveOpenLists.getInstance() == null) {
					saveAction = new SaveOpenLists();
					saveAction.saveAll(CustomerList.customerHoldingList,
							AccountList.accountHoldingList);
				} else {
					saveAction.saveAll(CustomerList.customerHoldingList,
							AccountList.accountHoldingList);
				}

			}
		});
		mnFile.add(mntmSaveAll);

		JMenuItem mntmSaveAccounts = new JMenuItem("Save Accounts");
		mntmSaveAccounts.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (SaveOpenLists.getInstance() == null) {
					saveAction = new SaveOpenLists();
					saveAction.saveCustomers(AccountList.accountHoldingList);
				} else {
					saveAction.saveAccounts(AccountList.accountHoldingList);
				}
			}
		});
		mnFile.add(mntmSaveAccounts);

		JMenuItem mntmSaveCustomers = new JMenuItem("Save Customers");
		mntmSaveCustomers.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (SaveOpenLists.getInstance().getSaveCustomerHoldingList() == null) {
					saveAction = new SaveOpenLists();
					saveAction.saveCustomers(CustomerList.customerHoldingList);
				} else {
					saveAction.saveCustomers(CustomerList.customerHoldingList);
				}
			}
		});
		mnFile.add(mntmSaveCustomers);
		mnFile.add(mntmExit);

		JMenu mnAccounts = new JMenu("Accounts");
		mnAccounts.setMnemonic('A');
		menuBar.add(mnAccounts);

		JMenuItem mntmAddNewAccount = new JMenuItem("Add New Account");
		mntmAddNewAccount.addActionListener(new ActionListener() {
	
			public void actionPerformed(ActionEvent e) {
				if (AddNewAccountGUI.getInstance() == null) {
					AddNewAccountGUI addAccount = new AddNewAccountGUI();
					addAccount.setVisible(true);
				} else {
					AddNewAccountGUI sameGUI = AddNewAccountGUI
							.getInstance();
					sameGUI.setVisible(true);
				}
			}
		});
		mnAccounts.add(mntmAddNewAccount);

		JMenu mnCustomer = new JMenu("Customer");
		mnCustomer.setMnemonic('C');
		menuBar.add(mnCustomer);

		JMenuItem mntmAddremoveCustomer = new JMenuItem("Add/Remove Customer");
		mntmAddremoveCustomer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (MaintainCustomersGUI.getInstance() == null) {
					MaintainCustomersGUI newMainGUI = new MaintainCustomersGUI();
					newMainGUI.setVisible(true);
				} else {
					MaintainCustomersGUI sameGUI = MaintainCustomersGUI
							.getInstance();
					sameGUI.setVisible(true);
				}
			}
		});
		mnCustomer.add(mntmAddremoveCustomer);

		JMenuItem mntmEditCustomer = new JMenuItem("Edit Customer ");
		mntmEditCustomer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (!(CustomerList.getInstance().getCustomerHoldingList()
						.isEmpty())) {
					EditCustomerGUI editCust = new EditCustomerGUI();
					editCust.setVisible(true);
				} else {
					JOptionPane.showMessageDialog(null,
							"There Are No Customers\n Create Customer First");
				}
			}
		});
		mnCustomer.add(mntmEditCustomer);

		JMenu mnReports = new JMenu("Reports");
		mnReports.setMnemonic('R');
		menuBar.add(mnReports);

		JMenuItem mntmGenerateReports = new JMenuItem("Generate Reports");
		mntmGenerateReports.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ReportsGUI reports = new ReportsGUI();
				reports.setVisible(true);
			}
		});
		mnReports.add(mntmGenerateReports);

		JSeparator separator_3 = new JSeparator();
		menuBar.add(separator_3);

		JSeparator separator_2 = new JSeparator();
		menuBar.add(separator_2);

		JSeparator separator_1 = new JSeparator();
		menuBar.add(separator_1);

		JSeparator separator = new JSeparator();
		menuBar.add(separator);
	}// end constructor

	public void run() {
		try {
			GUIMain frame = new GUIMain();
			frame.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
}
