package com.xeround.bankmark;
//Class GoldAccount
public class GoldAccount extends Account {
	/**
	 * 
	 */
	private static final long serialVersionUID = -2939903904016500261L;
	private double interestRate;
	private double monthlyCharge;
	private final double defaultMonthlyCharge = 10.00d;
	private final double defaultInterestRate = 0.05d;
	
	


	//start constructor
	public GoldAccount(Customer customer, double openingBalance, int accountNumber) {
		super(customer, openingBalance, accountNumber);
	 //don't have to explicitly define super here but helps me remember
	}//end constructor

	//start getInterestRate()
	public double getInterestRate() {
		return interestRate;
	}//end getInterestRate()
	public void setInterestRate(double intR) {
		this.interestRate = intR;
	}//end getInterestRate()

	//start deposit
	public void deposit(double depositAmount) {
		super.deposit(depositAmount);
	}//end deposit

//start update
	// method final because this is concrete class
	final void monthlyUpdate() {
		double tempBal = super.getBalance()
				+ (super.getBalance() * interestRate) + monthlyCharge;
		super.setBalance(tempBal);
	}// end update

	//start toString
	public String toString() {
		String checkAccInfo = super.toString();
		return String.format("%s", checkAccInfo);
	}//end toString

	@Override
	void withdraw(double amount) {	
				double tempBalance = super.getBalance() - amount;
				super.setBalance(tempBalance);
			}


	public double getMonthlyCharge() {
		return monthlyCharge;
	}

	public void setMonthlyCharge(double monthlyCharge) {
		this.monthlyCharge = monthlyCharge;
	}
	public double getDefaultInterestRate() {
		return defaultInterestRate;
	}

	public double getDefaultMonthlyCharge() {
		return defaultMonthlyCharge;
	}
	public void useDefaultInterestRate(){interestRate = defaultInterestRate;}
	public void useDefaultMonthlyCharge(){monthlyCharge = defaultMonthlyCharge;}
}//end Class GoldAccount
