package com.xeround.bankmark;

import java.awt.Window;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.JTextField;
import javax.swing.JList;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JLabel;
import java.awt.Font;
import java.awt.Color;
import javax.swing.JTextArea;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;

public class MaintainCustomersGUI extends JFrame {
	/**
	 * 
	 */
	private static final long serialVersionUID = -4661813715643809778L;
	private static MaintainCustomersGUI instance = null;
	private JPanel contentPane;
	final Window container = this;
	private JTextField custName;
	private JTextField custAddress;
	private JTextField custPhone;
	private JTextField custID;
	private String customerName;
	private int customerID;
	private String customerAddress;
	private String customerPhone;
	private MyListIterator cursor;
	private ImageIcon successIcon = new ImageIcon("images/success.png");
	private ImageIcon failIcon = new ImageIcon("images/fail.png");
	private Customer selectedCustomer;
	private MyListModel forJList = new MyListModel(); //list model uses enumeration and gets members
	//from the static customerHoldingList and then can be used to populate jlist
	JList<Customer> customerJlist = new JList<Customer>();
	private JTextArea textAreaCustInfo = new JTextArea();
	private JLabel lblcustNameError = new JLabel("");
	private JLabel lblcustAddressError = new JLabel("");
	private JLabel lblcustPhoneError = new JLabel("");
	private JLabel lblcustIDError = new JLabel("");
	//private JScrollBar vertical = new JScrollBar();
	/**
	 * Create the frame.
	 */
	public MaintainCustomersGUI() {
		cursor = CustomerList.getInstance().head();
		setTitle("Maintain Customers");
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(100, 100, 770, 350);
		contentPane = new JPanel();
		container.add(contentPane);
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		setLocation(600, 200);
		forJList.customerPopulateJList(customerJlist);
		customerJlist.setBackground(new Color(255, 255, 255));
		//vertical.setVisible(true);
		//customerJlist.add(vertical);
		
		textAreaCustInfo.setBackground(new Color(204, 204, 204));
		textAreaCustInfo.setLineWrap(true);
		//customerJlist.setSelectedIndex(selectedIndex);
		customerJlist.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				if (evt.getValueIsAdjusting()) {
					textAreaCustInfo.setText(customerJlist.getSelectedValue()
							.custAllInfotoString());
					setSelectedCustomer(customerJlist.getSelectedValue());
				}
			}
		});
		JButton btnClear = new JButton("Clear All Customers");
		btnClear.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// will throw IndexOutOfBoundsException, so using if else to
				// handle
				if (!(CustomerList.getInstance().getCustomerHoldingList()
						.isEmpty())) {
					String message = "Are you sure you want\n  to "
							+ "clear all customers?";
					String title = "Clear Customers";
					int reply = JOptionPane.showConfirmDialog(null,
							message, title, JOptionPane.YES_NO_OPTION);
					if (reply == JOptionPane.YES_OPTION) {
					CustomerList.getInstance().getCustomerHoldingList().clear();
					forJList.clearAll();
					forJList.customerPopulateJList(customerJlist);
					textAreaCustInfo.setText("");
					cursor = CustomerList.getInstance().getCursor();
					//cursor = CustomerList.getInstance()
					//		.getCustomerHoldingList().head();
				}
					} else {
					JOptionPane.showMessageDialog(null, "No Customers in list");
				}
			}
		});
		JLabel lblSelectedCustomerInfo = new JLabel("Selected Customer Info");
		lblSelectedCustomerInfo.setForeground(Color.BLUE);
		lblSelectedCustomerInfo.setFont(new Font("Tahoma", Font.PLAIN, 14));

		JLabel lblCustomerSelection = new JLabel("Customer Selection");
		lblCustomerSelection.setForeground(Color.BLUE);
		lblCustomerSelection.setFont(new Font("Tahoma", Font.PLAIN, 14));

		JButton btnRemoveSelectedCustomer = new JButton(
				"Remove Selected Customer");
		btnRemoveSelectedCustomer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// will throw IndexOutOfBoundsException, so using if else to
				// handle
				if (!(CustomerList.getInstance().getCustomerHoldingList()
						.isEmpty())) {
					if (!(customerJlist.isSelectionEmpty())) {
						String message = "Are you sure you want\n  to "
								+ "remove this customer?";
						String title = "Remove Customer";
						int reply = JOptionPane.showConfirmDialog(null,
								message, title, JOptionPane.YES_NO_OPTION);
						if (reply == JOptionPane.YES_OPTION) {
							CustomerList
									.getInstance()
									.getCustomerHoldingList()
									.remove(CustomerList.getInstance()
											.getCustomerHoldingList()
											.find(getSelectedCustomer()));
							forJList.customerPopulateJList(customerJlist);
							textAreaCustInfo.setText("");
							setSelectedCustomer(null);
						}
					}
				} else {
					JOptionPane.showMessageDialog(null, "No Customers Selected");
				}
			}
		});
		JLabel lblAddCustomer = new JLabel("Add Customer");
		lblAddCustomer.setForeground(Color.BLUE);
		lblAddCustomer.setFont(new Font("Tahoma", Font.PLAIN, 14));
		JLabel lblName = new JLabel("Name:");
		JLabel lblAddress = new JLabel("Address:");
		custName = new JTextField();
		custName.setColumns(10);
		custAddress = new JTextField();
		custAddress.setColumns(10);
		JLabel lblPhone = new JLabel("Phone:");
		custPhone = new JTextField();
		custPhone.setColumns(10);
		JLabel lblCustomerId = new JLabel("Customer ID:");
		custID = new JTextField();
		custID.setColumns(10);
		
		lblcustNameError.setEnabled(false);
		lblcustNameError.setForeground(Color.RED);
		
		lblcustAddressError.setEnabled(false);
		lblcustAddressError.setForeground(Color.RED);
		
		lblcustPhoneError.setEnabled(false);
		lblcustPhoneError.setForeground(Color.RED);
		
		lblcustIDError.setEnabled(false);
		lblcustIDError.setForeground(Color.RED);
		custName.addFocusListener(new FocusAdapter() {
			@Override
			public void focusLost(FocusEvent arg0) {
				String pattern = "\\w.*?";
				if (custName.getText().matches(pattern)) {
					
					lblcustNameError.setText("");
					lblcustNameError
							.setIcon(successIcon);
				} else {
					lblcustNameError.setText("Invalid, Name Required");
					lblcustNameError.setIcon(failIcon);
					lblcustNameError.setEnabled(false);
				}
			}
		});
		custAddress.addFocusListener(new FocusAdapter() {
			@Override
			public void focusLost(FocusEvent e) {
				String pattern = "\\w.*?";
				if (custAddress.getText().matches(pattern)) {
					lblcustAddressError.setText("");
					lblcustAddressError.setIcon(successIcon);
				} else {
					lblcustAddressError.setText("Invalid, Include Address");
					lblcustAddressError
							.setIcon(failIcon);
					lblcustAddressError.setEnabled(false);
				}
			}
		});
		custPhone.addFocusListener(new FocusAdapter() {
			@Override
			public void focusLost(FocusEvent e) {
				String pattern = "\\(*?\\d{3}[\\w'-]*?\\d{3}[\\w'-]*?\\d{4}";
				if (custPhone.getText().matches(pattern)) {
					lblcustPhoneError.setText("");
					lblcustPhoneError.setIcon(successIcon);
				} else {
					lblcustPhoneError.setText("Format 555-123-1234");
					lblcustPhoneError.setIcon(failIcon);
					lblcustPhoneError.setEnabled(false);
				}
			}
		});
		custID.addFocusListener(new FocusAdapter() {
			@Override
			public void focusLost(FocusEvent e) {
				String pattern = "\\d.*?";
				if (custID.getText().matches(pattern)) {
					lblcustIDError.setText("");
					lblcustIDError.setIcon(successIcon);
					lblcustIDError.setEnabled(true);
				} else {
					lblcustIDError.setText("Must be an Number");
					lblcustIDError.setIcon(failIcon);
					lblcustIDError.setEnabled(false);
				}
			}
		});
		JButton btnAddCustomerAfter = new JButton("Add Customer After Selected");
		btnAddCustomerAfter.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				String pattern = "\\w.*?";
				String pattern2 = "\\(*?\\d{3}[\\w'-]*?\\d{3}[\\w'-]*?\\d{4}";
				String pattern3 = "\\d.*?";
				if (!(customerJlist.isSelectionEmpty())){
				if (custName.getText().matches(pattern)) {
					if (custAddress.getText().matches(pattern)) {
						if (custPhone.getText().matches(pattern2)) {
							if (custID.getText().matches(pattern3)) {
								
								setCustomerName(custName.getText());
								setCustomerAddress(custAddress.getText());
								setCustomerPhone(custPhone.getText());
								setCustomerID(Integer.parseInt(custID.getText()));
								Customer newCustomer = new Customer(
										customerName, customerAddress,
										customerPhone, customerID);
								// must use null here or indexoutofbounds will
								// occur when doubly
								// list is cleared with remove all customers
								// button
								if (getSelectedCustomer() != null) {
									cursor = CustomerList.getInstance()
											.getCustomerHoldingList()
											.find(getSelectedCustomer());
								}
								CustomerList.getInstance()
										.getCustomerHoldingList()
										.insertAfter(newCustomer, cursor);
								forJList.customerPopulateJList(customerJlist);
								
							}
						}
					}
				}
			}else {
				JOptionPane.showMessageDialog(null, "You have to select a customer\n first " +
						"Add Customer if no \ncustomers are in Customer Selection");
			}
			}
		});
		JButton btnAddCustomerBefore = new JButton(
				"Add Customer Before Selected");
		btnAddCustomerBefore.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String pattern = "\\w.*?";
				String pattern2 = "\\(*?\\d{3}[\\w'-]*?\\d{3}[\\w'-]*?\\d{4}";
				String pattern3 = "\\d.*?";
				if (!(customerJlist.isSelectionEmpty())){
				if (custName.getText().matches(pattern)) {
					if (custAddress.getText().matches(pattern)) {
						if (custPhone.getText().matches(pattern2)) {
							if (custID.getText().matches(pattern3)) {							
								setCustomerName(custName.getText());
								setCustomerAddress(custAddress.getText());
								setCustomerPhone(custPhone.getText());
								setCustomerID(Integer.parseInt(custID.getText()));
								Customer newCustomer = new Customer(
										customerName, customerAddress,
										customerPhone, customerID);
								if (getSelectedCustomer() != null) {
									cursor = CustomerList.getInstance()
											.getCustomerHoldingList()
											.find(getSelectedCustomer());
									//System.out.println("not null");
								}
								CustomerList.getInstance()
										.getCustomerHoldingList()
										.insertBefore(newCustomer, cursor);
								forJList.customerPopulateJList(customerJlist);
							}
						}
					}
				}
			}else {
				JOptionPane.showMessageDialog(null, "You have to select a customer\n first " +
						"Add Customer if no \ncustomers are in Customer Selection");
			}
				}
		});
		JButton btnClose = new JButton("Close");
		btnClose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				container.dispose();
			}
		});	
		JButton btnAddCustomer = new JButton("Add Customer");
		btnAddCustomer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String pattern = "\\w.*?";
				String pattern2 = "\\(*?\\d{3}[\\w'-]*?\\d{3}[\\w'-]*?\\d{4}";
				String pattern3 = "\\d.*?";
				if (custName.getText().matches(pattern)) {
					if (custAddress.getText().matches(pattern)) {
						if (custPhone.getText().matches(pattern2)) {
							if (custID.getText().matches(pattern3)) {							
								setCustomerName(custName.getText());
								setCustomerAddress(custAddress.getText());
								setCustomerPhone(custPhone.getText());
								try{
								setCustomerID(Integer.parseInt(custID.getText()));
								}catch (NumberFormatException ex){
									JOptionPane.showMessageDialog(null, "Must be a number");
								}
								Customer newCustomer = new Customer(
										customerName, customerAddress,
										customerPhone, customerID);
								CustomerList.getInstance()
										.getCustomerHoldingList()
										.insertAfter(newCustomer, cursor);
								
								forJList.customerPopulateJList(customerJlist);
								//System.out.print("ok add customer button 349");
							}
						}
					}
				}
				}
		});
		
		JButton btnNewButton = new JButton("Clear TextFields");
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				custName.setText("");
				custAddress.setText("");
				custPhone.setText("");
				custID.setText("");
				lblcustNameError.setText("");
				lblcustAddressError.setText("");
				lblcustPhoneError.setText("");
				lblcustIDError.setText("");
			}
		});
		GroupLayout gl_contentPane = new GroupLayout(contentPane);
		gl_contentPane.setHorizontalGroup(
			gl_contentPane.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addComponent(customerJlist, GroupLayout.DEFAULT_SIZE, 174, Short.MAX_VALUE)
							.addGap(23))
						.addGroup(gl_contentPane.createSequentialGroup()
							.addContainerGap()
							.addComponent(lblCustomerSelection)))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addComponent(lblSelectedCustomerInfo)
							.addGap(58))
						.addGroup(gl_contentPane.createSequentialGroup()
							.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
								.addComponent(textAreaCustInfo, GroupLayout.PREFERRED_SIZE, 189, Short.MAX_VALUE)
								.addComponent(btnRemoveSelectedCustomer, Alignment.LEADING, GroupLayout.DEFAULT_SIZE, 189, Short.MAX_VALUE)
								.addComponent(btnClear, Alignment.LEADING, GroupLayout.DEFAULT_SIZE, 189, Short.MAX_VALUE))
							.addGap(29)))
					.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
						.addComponent(lblAddCustomer)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addPreferredGap(ComponentPlacement.RELATED)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
								.addComponent(lblAddress)
								.addComponent(lblName)
								.addComponent(lblPhone)
								.addComponent(lblCustomerId))
							.addPreferredGap(ComponentPlacement.RELATED)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
								.addGroup(gl_contentPane.createSequentialGroup()
									.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
										.addComponent(custPhone, GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
										.addComponent(custID, GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
										.addComponent(custAddress, GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
										.addComponent(custName, GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE))
									.addPreferredGap(ComponentPlacement.RELATED)
									.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
										.addComponent(lblcustIDError, GroupLayout.DEFAULT_SIZE, 112, Short.MAX_VALUE)
										.addComponent(lblcustPhoneError, GroupLayout.DEFAULT_SIZE, 112, Short.MAX_VALUE)
										.addComponent(lblcustAddressError, GroupLayout.DEFAULT_SIZE, 112, Short.MAX_VALUE)
										.addComponent(lblcustNameError, GroupLayout.DEFAULT_SIZE, 112, Short.MAX_VALUE)))
								.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING, false)
									.addComponent(btnAddCustomer, Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
									.addComponent(btnAddCustomerAfter, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
									.addComponent(btnAddCustomerBefore, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
									.addGroup(gl_contentPane.createSequentialGroup()
										.addComponent(btnNewButton)
										.addPreferredGap(ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
										.addComponent(btnClose))))))
					.addContainerGap())
		);
		gl_contentPane.setVerticalGroup(
			gl_contentPane.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addContainerGap()
					.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
								.addGroup(gl_contentPane.createSequentialGroup()
									.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
										.addComponent(lblSelectedCustomerInfo)
										.addComponent(lblAddCustomer))
									.addGap(8)
									.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
										.addGroup(gl_contentPane.createSequentialGroup()
											.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
												.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
													.addComponent(custName, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
													.addComponent(lblcustNameError, GroupLayout.PREFERRED_SIZE, 20, GroupLayout.PREFERRED_SIZE))
												.addComponent(lblName))
											.addGap(8)
											.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
												.addComponent(lblAddress)
												.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
													.addComponent(custAddress, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
													.addComponent(lblcustAddressError, GroupLayout.PREFERRED_SIZE, 22, GroupLayout.PREFERRED_SIZE)))
											.addPreferredGap(ComponentPlacement.RELATED)
											.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
												.addComponent(lblPhone)
												.addComponent(lblcustPhoneError, GroupLayout.PREFERRED_SIZE, 22, GroupLayout.PREFERRED_SIZE)
												.addComponent(custPhone, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
											.addPreferredGap(ComponentPlacement.RELATED)
											.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
												.addComponent(lblCustomerId)
												.addComponent(lblcustIDError, GroupLayout.PREFERRED_SIZE, 23, GroupLayout.PREFERRED_SIZE)
												.addComponent(custID, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
										.addGroup(gl_contentPane.createSequentialGroup()
											.addPreferredGap(ComponentPlacement.RELATED)
											.addComponent(textAreaCustInfo, GroupLayout.PREFERRED_SIZE, 107, GroupLayout.PREFERRED_SIZE)))
									.addGap(11)
									.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
										.addGroup(gl_contentPane.createSequentialGroup()
											.addComponent(btnRemoveSelectedCustomer)
											.addPreferredGap(ComponentPlacement.RELATED)
											.addComponent(btnClear, GroupLayout.PREFERRED_SIZE, 25, GroupLayout.PREFERRED_SIZE))
										.addGroup(gl_contentPane.createSequentialGroup()
											.addComponent(btnAddCustomer)
											.addPreferredGap(ComponentPlacement.RELATED)
											.addComponent(btnAddCustomerAfter)
											.addGap(5))))
								.addGroup(Alignment.LEADING, gl_contentPane.createSequentialGroup()
									.addComponent(lblCustomerSelection)
									.addPreferredGap(ComponentPlacement.RELATED)
									.addComponent(customerJlist, GroupLayout.DEFAULT_SIZE, 177, Short.MAX_VALUE)))
							.addGap(28))
						.addComponent(btnAddCustomerBefore))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
						.addComponent(btnClose)
						.addComponent(btnNewButton))
					.addGap(40))
		);
		contentPane.setLayout(gl_contentPane);
	}

	public String getCustomerName() {
		return customerName;
	}

	public void setCustomerName(String customerName) {
		this.customerName = customerName;
	}

	public int getCustomerID() {
		return customerID;
	}

	public void setCustomerID(int customerID) {
		this.customerID = customerID;
	}

	public String getCustomerAddress() {
		return customerAddress;
	}

	public void setCustomerAddress(String customerAddress) {
		this.customerAddress = customerAddress;
	}

	public String getCustomerPhone() {
		return customerPhone;
	}

	public void setCustomerPhone(String customerPhone) {
		this.customerPhone = customerPhone;
	}

	public Customer getSelectedCustomer() {
		return selectedCustomer;
	}

	public void setSelectedCustomer(Customer selectedCustomer) {
		this.selectedCustomer = selectedCustomer;
	}

	public static MaintainCustomersGUI getInstance() {
		if (instance == null) {
			instance = new MaintainCustomersGUI();
		}
		return instance;
	}
}
