package com.xeround.bankmark;

import java.io.Serializable;
import java.util.*;

public class MyDoubleyList implements Serializable {
	
	MyListItem head;
	private int num;

	// start constructor

	public MyDoubleyList() { // here
		head = new MyListItem(null);
		head.next = head.previous = head;
	}// end constructor

	public int size() {
		return num;
	}

	// clear the list of all the items or objects
	public void clear() {
		head.next = head.previous = head;
		num = 0;
	}// end clear method

	// if the head.next position is equivalent to itself then list is empty
	public boolean isEmpty() {
		return head.next == head;
		// or could use num == 0;
	}// end isEmpty method

	// insert the Account object
	public void insertAfter(Object obj, MyListIterator insertAfterPosition) {
		MyListItem newItem = new MyListItem(insertAfterPosition.position, obj,
				insertAfterPosition.position.next);
		newItem.next.previous = newItem;
		insertAfterPosition.position.next = newItem;
		num++;
	}

	/*
	 * insert element before current position
	 */
	public void insertBefore(Object obj, MyListIterator insertBeforePosition) {
		MyListItem newItem = new MyListItem(
				insertBeforePosition.position.previous, obj,
				insertBeforePosition.position);
		newItem.previous.next = newItem;
		insertBeforePosition.position.previous = newItem;
		num++;
	}

	/*
	 * remove the element at current position
	 */
	public void remove(MyListIterator removePosition) {
		if (isEmpty()) {
			throw new IndexOutOfBoundsException("empty list.");
		}
		if (removePosition.position == head) {
			throw new NoSuchElementException("cannot remove the head");
		}
		removePosition.position.previous.next = removePosition.position.next;
		removePosition.position.next.previous = removePosition.position.previous;
		num--;
	}

	/*
	 * Return an iterator positioned at the head.
	 */
	public MyListIterator head() {
		return new MyListIterator(this, head);
	}

	/*
	 * find the first occurrence of the object in a list
	 */
	public MyListIterator find(Object thePassedObject) {
		if (isEmpty()) {
			throw new IndexOutOfBoundsException("empty list.");
		}
		MyListItem firstItem = head;
		while (firstItem.next != head) { // There are still elements to be
											// inspected
			firstItem = firstItem.next;
			if (firstItem.objectThing == thePassedObject) {
				return new MyListIterator(this, firstItem);
			}
		}
		throw new NoSuchElementException("no such object found");
	}

	/*
	 * Returns an enumeration of the elements. Use the Enumeration methods on
	 * the returned object to fetch the elements sequentially.
	 */
	public Enumeration<?> members() {
		return new MyListEnumerator(this);
	}

	// ##################toStrings
	public String printAllCustInfo() {
		MyListEnumerator thisEnumerator = (MyListEnumerator) this.members();
		String str = "";
		while (thisEnumerator.hasMoreElements()) {
			Customer obj = (Customer) thisEnumerator.nextElement();
			str += String.format("\n%s", obj.custAllInfotoString());
		}
		return str;
	}

	public String custNameToString() {
		MyListEnumerator thisEnumerator = (MyListEnumerator) this.members();
		String str = "";
		while (thisEnumerator.hasMoreElements()) {
			Customer obj = (Customer) thisEnumerator.nextElement();
			str += String.format("\n%s", obj.custNameToString());
		}
		return str;
	}
	public String accNumberToString() {
		MyListEnumerator thisEnumerator = (MyListEnumerator) this.members();
		String str = "";
		while (thisEnumerator.hasMoreElements()) {
			Account obj = (Account) thisEnumerator.nextElement();
			str += String.format("\n%s", obj.getAccountNumberToString());
		}
		return str;
	}

	public String custAddressToString() {
		MyListEnumerator thisEnumerator = (MyListEnumerator) this.members();
		String str = "";
		while (thisEnumerator.hasMoreElements()) {
			Customer obj = (Customer) thisEnumerator.nextElement();
			str += String.format("\n%s", obj.custAddressToString());
		}
		return str;
	}

	public String custPhoneToString() {
		MyListEnumerator thisEnumerator = (MyListEnumerator) this.members();
		String str = "";
		while (thisEnumerator.hasMoreElements()) {
			Customer obj = (Customer) thisEnumerator.nextElement();
			str += String.format("\n%s", obj.custPhoneToString());
		}
		return str;
	}

	public String custIDToString() {
		MyListEnumerator thisEnumerator = (MyListEnumerator) this.members();
		String str = "";
		while (thisEnumerator.hasMoreElements()) {
			Customer obj = (Customer) thisEnumerator.nextElement();
			str += String.format("\n%s", obj.custIDToString());
		}
		return str;
	}

}
