package com.xeround.bankmark;
import javax.swing.JOptionPane;

//Class RegularAccount
public class RegularAccount extends Account {
	/**
	 * 
	 */
	private static final long serialVersionUID = -7406233554915885451L;
	private double interestRate;
	private final double defaultInterestRate = 0.06d;
	private double monthlyCharge;
	private final double defaultMonthlyCharge = 10.00d;

	// start constructor
	public RegularAccount(Customer customer, double openingBalance, int accountNumber) {
		super(customer, openingBalance, accountNumber);
		useDefaultMonthlyCharge();
		useDefaultInterestRate();
	}// end constructor
	public void useDefaultInterestRate(){
	interestRate = defaultInterestRate;
	}
	public void useDefaultMonthlyCharge(){
		setMonthlyCharge(defaultMonthlyCharge);
	}
	// start getInterestRate()
	public double getInterestRate() {
		return interestRate;
	}// end getInterestRate

	// start deposit
	public void deposit(double amount) {
		super.deposit(amount);
	}// end deposit

	@Override
	// method overrides account's update method
	// method final because this is concrete class
	final void monthlyUpdate() {
		double temBal = super.getBalance()
				+ (super.getBalance() * interestRate) + monthlyCharge;
		super.setBalance(temBal);
	}// end update

	// Polymorphic behavior here as this withdraw() overrides Account's
	// withdraw()//method final because this is concrete class
	@Override
	final void withdraw(double amount) {
				if (amount <= super.getBalance()) {
					double tempBal = super.getBalance() - amount;
					super.setBalance(tempBal);
				} else {
					JOptionPane.showMessageDialog(null, "Insufficient Funds");
				}
	}// end withdraw

	// start toString
	public String toString() {
		String regAccInfo = super.toString();
		return String.format("%s", regAccInfo);
	}//end toString

	public double getMonthlyCharge() {
		return monthlyCharge;
	}
	public void setMonthlyCharge(double monthlyCharge) {
		this.monthlyCharge = monthlyCharge;
	}
	public void setInterestRate(double intRate) {
		this.interestRate = intRate;
		
	}


}// end Class RegularAccount
