package com.xeround.bankmark;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;

import javax.swing.JOptionPane;

//This class is for saving data. The lists can be passed and saved
//saving AccounLists and CustomerLists sets the static variables customerHoldingList
//and accountHoldingList to this classes variables and opening the lists
//sets the static variables from their respected files. This allows for the user
//to undo progress after they have saved and before saving again.
public class SaveOpenLists implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3676816520921390093L;
	private static SaveOpenLists instance;
	//making these two lists static because when I use an instance of this class
 MyDoubleyList saveCustomerHoldingList;
 MyDoubleyList saveAccountHoldingList;
	String message = "Do You want to Save Your Progress?";
	String titleCustomers = "Save Customers";
	String titleAccounts = "Save Accounts";

	public void saveCustomers(MyDoubleyList customerList) {
		this.saveCustomerHoldingList = customerList;
		try {
			// confirm saving customers
			int reply = JOptionPane.showConfirmDialog(null, message,
					titleCustomers, JOptionPane.YES_NO_OPTION);
			if (reply == JOptionPane.YES_OPTION) {
				// make sure there are customers in the list
				if (!(saveCustomerHoldingList.isEmpty())) {
					FileOutputStream custTempFile = new FileOutputStream(
							"customers.dat");
					ObjectOutputStream writable = new ObjectOutputStream(
							custTempFile);
					writable.writeObject(this.saveCustomerHoldingList);
					writable.close();
				} else {
					JOptionPane.showMessageDialog(null, "No Customers in List");
				}
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Unable to Save Customers");
			e.printStackTrace();
		}

	}

	public void saveAccounts(MyDoubleyList accountList) {
		this.saveAccountHoldingList = accountList;
		try {
			// confirm saving customers
			int reply = JOptionPane.showConfirmDialog(null, message,
					titleAccounts, JOptionPane.YES_NO_OPTION);
			if (reply == JOptionPane.YES_OPTION) {
				// make sure there are customers in the list
				if (!(saveAccountHoldingList.isEmpty())) {
					FileOutputStream accTempFile = new FileOutputStream(
							"accounts.dat");
					ObjectOutputStream writable = new ObjectOutputStream(
							accTempFile);
					writable.writeObject(this.saveAccountHoldingList);
					writable.close();
				} else {
					JOptionPane.showMessageDialog(null, "No Accountss in List");
				}
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Unable to Save Accounts");
			e.printStackTrace();
		}
	}

	public void saveAll(MyDoubleyList customerList, MyDoubleyList accountList) {
		this.saveCustomerHoldingList = customerList;
		this.saveAccountHoldingList = accountList;
		try {
			// confirm saving customers
			// make sure there are customers in the list
			FileOutputStream custTempFile = new FileOutputStream(
					"customers.dat");
			FileOutputStream accTempFile = new FileOutputStream("accounts.dat");
			ObjectOutputStream custWritable = new ObjectOutputStream(
					custTempFile);
			ObjectOutputStream accWritable = new ObjectOutputStream(accTempFile);
			custWritable.writeObject(this.saveCustomerHoldingList);
			accWritable.writeObject(this.saveAccountHoldingList);
			custWritable.close();
			accWritable.close();
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Unable to Save");
			e.printStackTrace();
		}
	}

///##############   open lists   ########### this is where I will have to set 
	//the static variables for customerHoldingList and AccountHoldingList
	//instead of the class variables.
	public void openAccounts() {
		try {
			FileInputStream accFile = new FileInputStream("accounts.dat");
			ObjectInputStream accStream = new ObjectInputStream(accFile);
			MyDoubleyList list = (MyDoubleyList) accStream.readObject();
			AccountList.getInstance().setAccountHoldingList(list);
			accStream.close();
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Unable to Open Accounts");
			e.printStackTrace();
		}

	}
	public void openCustomers() {
		try {
			FileInputStream custFile = new FileInputStream("customers.dat");
			ObjectInputStream custStream = new ObjectInputStream(custFile);
			MyDoubleyList list = (MyDoubleyList) custStream.readObject();
			CustomerList.getInstance().setCustomerHoldingList(list);
			custStream.close();
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Unable to Open Customers");
			e.printStackTrace();
		}

	}
	//############### Getters an Setters
	public MyDoubleyList getSaveCustomerHoldingList() {
		return saveCustomerHoldingList;
	}

	public void setSaveCustomerHoldingList(MyDoubleyList saveCustomerHoldingList) {
		this.saveCustomerHoldingList = saveCustomerHoldingList;
	}

	public MyDoubleyList getSaveAccountHoldingList() {
		return saveAccountHoldingList;
	}

	public void setSaveAccountHoldingList(MyDoubleyList saveAccountHoldingList) {
		this.saveAccountHoldingList = saveAccountHoldingList;
	}
	public static SaveOpenLists getInstance() {
	      if(instance == null) {
	         instance = new SaveOpenLists();
	      }
	      return instance;
	   }
}
