package com.xeround.bankmark;

import java.awt.Window;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JList;
import javax.swing.JLabel;
import javax.swing.LayoutStyle.ComponentPlacement;
import java.awt.Font;
import java.awt.Color;

import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.ButtonGroup;
import javax.swing.JTextArea;
import javax.swing.ListSelectionModel;

public class TransactionGUI extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7559285859031957067L;
	private static TransactionGUI instance = null;
	private JPanel contentPane;
	final Window container = this;
	private JTextField transAmount;
	MyListModelAccounts forJList = new MyListModelAccounts();// listmodel to populate														// jlist with mydoubly														// list
	private final ButtonGroup buttonGroup = new ButtonGroup();
	private JList<Account> accountJList = new JList<Account>();
	JTextArea textArea = new JTextArea();
	private Account selectedAccount;
	SelectedFromButtonGroup bgSelected = new SelectedFromButtonGroup(); // check
	private String withdrawString = "Withdraw";
	private String depositString = "Deposit";
	private String actionSelectedFromRadio; // selected button from radio button
											// group
	private double transactionAmount;

	/**
	 * Create the frame.
	 */
	public TransactionGUI() {
		
		setTitle("Make Transaction");
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(100, 100, 450, 225);
		contentPane = new JPanel();
		container.add(contentPane);
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);

		
		JLabel lblAccounts = new JLabel("Accounts");
		lblAccounts.setForeground(new Color(0, 51, 255));
		lblAccounts.setFont(new Font("Tahoma", Font.PLAIN, 14));
		forJList.accountPopulateJList(accountJList);
		JRadioButton rdbtnDeposit = new JRadioButton("Deposit");
		rdbtnDeposit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (!(accountJList.isSelectionEmpty())) {
					actionSelectedFromRadio = bgSelected
							.getSelectedButton(buttonGroup);

				} else {
					buttonGroup.clearSelection();
					JOptionPane.showMessageDialog(null,
							"Select a Account to\n deposit or Withdraw from");
				}
			}
		});
		buttonGroup.add(rdbtnDeposit);
		rdbtnDeposit.setFont(new Font("Tahoma", Font.PLAIN, 12));

		JRadioButton rdbtnWithdraw = new JRadioButton("Withdraw");
		rdbtnWithdraw.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (!(accountJList.isSelectionEmpty())) {
					actionSelectedFromRadio = bgSelected
							.getSelectedButton(buttonGroup);

				} else {
					buttonGroup.clearSelection();
					JOptionPane.showMessageDialog(null,
							"Select a Account to\n deposit or Withdraw from");
				}
			}
		});
		buttonGroup.add(rdbtnWithdraw);

		JLabel lblAmount = new JLabel("Amount:");
		lblAmount.setFont(new Font("Tahoma", Font.PLAIN, 12));

		transAmount = new JTextField();
		transAmount.setColumns(10);

		JButton btnClose = new JButton("Close");
		btnClose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				container.dispose();
			}
		});

		JButton btnProcess = new JButton("Process");
		btnProcess.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (actionSelectedFromRadio == depositString) {
					setSelectedAccount(accountJList.getSelectedValue());
					try {
						setTransactionAmount(Double.parseDouble(transAmount
								.getText()));
						selectedAccount.deposit(transactionAmount);
						JOptionPane.showMessageDialog(null,  "Deposit Successfull");
						forJList.accountPopulateJList(accountJList);
						textArea.setText(selectedAccount.accountAllInfotoString());
					} catch (Exception exc) {
						JOptionPane.showMessageDialog(null,  "Enter a dollar amount");
					}
					
				}
				if (actionSelectedFromRadio == withdrawString) {
					setSelectedAccount(accountJList.getSelectedValue());
					try {
						setTransactionAmount(Double.parseDouble(transAmount
								.getText()));
						selectedAccount.withdraw(transactionAmount);
						JOptionPane.showMessageDialog(null,  "Withdraw Successfull");
						forJList.accountPopulateJList(accountJList);
						textArea.setText(selectedAccount.accountAllInfotoString());
					} catch (Exception exc) {
						JOptionPane.showMessageDialog(null,  "Enter a dollar amount");
					}
				}
			}
		});

		textArea.setBackground(Color.LIGHT_GRAY);
		textArea.setEditable(false);

		JLabel lblAccountInformation = new JLabel("Account Information");
		accountJList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		accountJList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				if (evt.getValueIsAdjusting()) {
					textArea.setText(accountJList.getSelectedValue()
							.accountAllInfotoString());
					setSelectedAccount(accountJList.getSelectedValue());
				}
			}
		});
		GroupLayout gl_contentPane = new GroupLayout(contentPane);
		gl_contentPane
				.setHorizontalGroup(gl_contentPane
						.createParallelGroup(Alignment.LEADING)
						.addGroup(
								gl_contentPane
										.createSequentialGroup()
										.addContainerGap()
										.addGroup(
												gl_contentPane
														.createParallelGroup(
																Alignment.LEADING)
														.addComponent(
																accountJList,
																GroupLayout.PREFERRED_SIZE,
																140,
																GroupLayout.PREFERRED_SIZE)
														.addComponent(
																lblAccounts))
										.addPreferredGap(
												ComponentPlacement.RELATED)
										.addGroup(
												gl_contentPane
														.createParallelGroup(
																Alignment.LEADING)
														.addComponent(
																textArea,
																GroupLayout.PREFERRED_SIZE,
																118,
																GroupLayout.PREFERRED_SIZE)
														.addComponent(
																lblAccountInformation))
										.addPreferredGap(
												ComponentPlacement.RELATED)
										.addGroup(
												gl_contentPane
														.createParallelGroup(
																Alignment.LEADING)
														.addGroup(
																gl_contentPane
																		.createSequentialGroup()
																		.addGap(70)
																		.addComponent(
																				btnClose,
																				GroupLayout.PREFERRED_SIZE,
																				78,
																				GroupLayout.PREFERRED_SIZE))
														.addGroup(
																gl_contentPane
																		.createSequentialGroup()
																		.addGap(26)
																		.addGroup(
																				gl_contentPane
																						.createParallelGroup(
																								Alignment.LEADING)
																						.addComponent(
																								btnProcess,
																								GroupLayout.PREFERRED_SIZE,
																								122,
																								GroupLayout.PREFERRED_SIZE)
																						.addComponent(
																								transAmount,
																								GroupLayout.PREFERRED_SIZE,
																								GroupLayout.DEFAULT_SIZE,
																								GroupLayout.PREFERRED_SIZE)
																						.addComponent(
																								rdbtnWithdraw,
																								GroupLayout.PREFERRED_SIZE,
																								88,
																								GroupLayout.PREFERRED_SIZE)
																						.addComponent(
																								rdbtnDeposit)
																						.addComponent(
																								lblAmount))))
										.addGap(2)));
		gl_contentPane
				.setVerticalGroup(gl_contentPane
						.createParallelGroup(Alignment.LEADING)
						.addGroup(
								Alignment.TRAILING,
								gl_contentPane
										.createSequentialGroup()
										.addGroup(
												gl_contentPane
														.createParallelGroup(
																Alignment.TRAILING)
														.addGroup(
																gl_contentPane
																		.createSequentialGroup()
																		.addContainerGap()
																		.addComponent(
																				lblAccountInformation)
																		.addGap(16)
																		.addComponent(
																				textArea,
																				GroupLayout.PREFERRED_SIZE,
																				125,
																				GroupLayout.PREFERRED_SIZE))
														.addGroup(
																gl_contentPane
																		.createSequentialGroup()
																		.addGroup(
																				gl_contentPane
																						.createParallelGroup(
																								Alignment.BASELINE)
																						.addComponent(
																								rdbtnWithdraw)
																						.addComponent(
																								lblAccounts))
																		.addPreferredGap(
																				ComponentPlacement.RELATED)
																		.addGroup(
																				gl_contentPane
																						.createParallelGroup(
																								Alignment.TRAILING)
																						.addGroup(
																								gl_contentPane
																										.createSequentialGroup()
																										.addComponent(
																												rdbtnDeposit)
																										.addGap(18)
																										.addComponent(
																												lblAmount)
																										.addGap(4)
																										.addComponent(
																												transAmount,
																												GroupLayout.PREFERRED_SIZE,
																												GroupLayout.DEFAULT_SIZE,
																												GroupLayout.PREFERRED_SIZE)
																										.addGap(8)
																										.addComponent(
																												btnProcess)
																										.addPreferredGap(
																												ComponentPlacement.RELATED,
																												GroupLayout.DEFAULT_SIZE,
																												Short.MAX_VALUE)
																										.addComponent(
																												btnClose))
																						.addComponent(
																								accountJList,
																								GroupLayout.DEFAULT_SIZE,
																								141,
																								Short.MAX_VALUE))))
										.addContainerGap()));
		contentPane.setLayout(gl_contentPane);
		setLocation(600, 200);
	}

	public Account getSelectedAccount() {
		return selectedAccount;
	}

	public void setSelectedAccount(Account selectedAccount) {
		this.selectedAccount = selectedAccount;
	}

	public double getTransactionAmount() {
		return transactionAmount;
	}

	public void setTransactionAmount(double transactionAmount) {
		this.transactionAmount = transactionAmount;
	}
	public static TransactionGUI getInstance() {
		if (instance == null) {
			instance = new TransactionGUI();
		}
		return instance;
	}
}
